function analym(par,num,den,ts,name);
%function analym(par,num,den,ts,name);
%analyses model "num"/"den" with sampling time "ts" and name "name"; contains also methods
%for model analyse window
%inputs:
%par ...	method number: 1=creat window, 2=real-imag to omega-xi conversion of displying poles/zeros, 

PREC=1e-8;
global colorset;
if(par==1)%create window
   A=den;
   B=num;
   Ts=ts;
	if(isempty(A)) return;end;
   %analysis
	%test order of the dynamics
	integrator=0;
   r=roots(A);
   rn=[];
   for k=1:length(r),
      if (abs(real(r(k))-1)<PREC)&(abs(imag(r(k)))<PREC), 
         integrator=integrator+1;
      else
         rn=[rn;r(k)];
      end;
   end;
   Ams=poly(rn);
   sint=num2str(integrator);
   sA=num2str(A);
   
	ord=size(Ams);
   if(ord(2)>2)
	   [mag,wnall,xiall]=ddamp(Ams,Ts);
	   [wnmin,index]=min(wnall);
	   [wnmax,index]=max(wnall);
      if(xiall(index)<0.7) str='is';else str='is not';end;
      prompt=sprintf(' system %s oscilatory, dynamic order is > 1',str);
   elseif(ord(2)==2)
      prompt=sprintf(' dynamic has only 1 pole p=%g',roots(Ams));
   elseif(ord(2)==1)
      prompt=sprintf(' there is not dynamic in th model');
   end;
   if(isempty(B)~=1)
	   K=1;
	   while(B(K)==0) K=K+1;end;
	   for J=K:length(B) auxB(J-K+1)=B(J);end;
      sB=num2str(auxB);
      sd=num2str(K-1);
   else
      sB='';sd='';
   end;
   %list of poles and zeros
   p=roots(A);
   for K=1:length(p)
      s=sprintf('%g  %gi',real(p(K)),imag(p(K)));
      listp(K)=cellstr(s);
	end;
   p=roots(B);
   if(isempty(p))
      listz={' '};
   else
	   for K=1:length(p)
	      s=sprintf('%g %gi',real(p(K)),imag(p(K)));
	      listz(K)=cellstr(s);
      end;
   end;
   global analy_mod;
   analy_mod=struct('num',B,'den',A,'Ts',Ts);
   
   h0=gcf;
   set(h0,'Unit','pixel');
   pmain=get(h0,'Position');
   set(h0,'Unit','point');
   ped=[454 279 560 420];
   ped(1)=pmain(1)+(pmain(3)-ped(3))/2;
   ped(2)=pmain(2)+(pmain(4)-ped(4))/2;
hw = figure('Color',getfield(colorset,'Background'), ...
	'MenuBar','none', ...
   'Position',ped, ...
   'Name',name, ...
   'Resize','off', ...
   'Deletefcn','analym(30);', ...
	'Tag','Fig1');
hlist_p = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[8.25 192 127.5 54], ...
	'String',listp, ...
	'Style','listbox', ...
	'Tag','Listpoles', ...
	'Value',1);
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[70.5 10.5 84.25 14.25], ...
	'String','Integrators:', ...
	'Style','text', ...
	'Tag','StaticText1');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[38.625 246 66.75 15], ...
	'String','Model Poles ', ...
	'Style','text', ...
	'Tag','StaticText2');
hbut = uicontrol('Parent',hw, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[363.75 9.75 45 15], ...
   'String','OK', ...
   'Callback','analym(31);', ...
	'Tag','Pushbutton1');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[154.75 14 26.25 10], ...
	'String',sint, ...
	'Style','text', ...
	'Tag','integrator');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[188 14 160 10], ...
	'String',prompt, ...
	'Style','text', ...
	'Tag','oscil');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[38.625 168.75 66.75 15], ...
	'String','Model Zeros ', ...
	'Style','text', ...
	'Tag','StaticText2');
hch_ri = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'ListboxTop',0, ...
	'Position',[8.25 291.75 90 15], ...
   'String','real + imaginary part', ...
   'CallBack','analym(11);', ...
	'Style','checkbox', ...
	'Tag','Checkbox1', ...
	'Value',1);
hch_fd = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[8.25 273 90 15], ...
   'String','nat.freq.[Hz] + damp.', ...
   'CallBack','analym(12);', ...
	'Style','checkbox', ...
	'Tag','Checkbox1');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[8.25 68.25 400 13.5], ...
	'String',sA, ...
	'Style','edit', ...
	'Tag','coeffA');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[8.25 81.75 200 15], ...
	'String','Denominator coefficients [1 d1 ... dNd]', ...
	'Style','text', ...
	'Tag','StaticText2');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[8.25 49.5 200 15], ...
	'String','Numerator coefficients [n1 ... nNn]', ...
	'Style','text', ...
	'Tag','StaticText2');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[8.25 36 400 13.5], ...
	'String',sB, ...
	'Style','edit', ...
	'Tag','coeffB');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[68.25 14 26.25 10], ...
	'String',sd, ...
	'Style','text', ...
	'Tag','delay');
h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[8.25 10.5 60 14.25], ...
	'String','Real delay:', ...
	'Style','text', ...
	'Tag','StaticText1');
hlist_z = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[8.25 114.75 127.5 54], ...
	'String',listz, ...
	'Style','listbox', ...
	'Tag','Listzeros', ...
	'Value',1);
h1 = axes('Parent',hw, ...
	'Box','on', ...
	'CameraUpVector',[0 1 0], ...
	'Color',getfield(colorset,'Axes'), ...
	'FontSize',8, ...
	'Position',[0.4196428571428571 0.3785714285714286 0.5642857142857143 0.5523809523809524], ...
	'Tag','Axes1', ...
	'XColor',[0 0 0], ...
	'XGrid','on', ...
	'YColor',[0 0 0], ...
	'YGrid','on', ...
   'ZColor',[0 0 0]);
hax=h1;
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[0.4984126984126984 -0.09482758620689658 9.160254037844386], ...
	'Tag','Axes1Text4', ...
	'VerticalAlignment','cap');
set(get(h2,'Parent'),'XLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[-0.08253968253968258 0.4956896551724137 9.160254037844386], ...
	'Rotation',90, ...
	'Tag','Axes1Text3', ...
	'VerticalAlignment','baseline');
set(get(h2,'Parent'),'YLabel',h2);

h1 = uicontrol('Parent',hw, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[230.625 294.75 128.25 13.5], ...
	'String','Pole - Zero Map of Model', ...
	'Style','text', ...
   'Tag','StaticText2');

hpop_ax = uicontrol('Parent',hw, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[177.75 296.25 234 15], ...
	'String',' ', ...
   'Style','popupmenu', ...
   'Callback','analym(13);', ...
	'Tag','PopupMenu1', ...
	'Value',1);
   sax={'Pole-Zero Map','Frequency Response - Amplitude','Frequency Response - Phase'};
   set(hpop_ax,'String',sax);
   
   global hanaly;
   hanaly=[hlist_p hlist_z hch_ri hch_fd hw hpop_ax hax];
	analym(13);%display graph
   
elseif(par==11)%change pole zero display to real-imag
   global hanaly; 
   global analy_mod;
   A=analy_mod.den;
   B=analy_mod.num;
   Ts=analy_mod.Ts;
   set(hanaly(4),'Value',0);
   %list of poles and zeros
   p=roots(A);
   for K=1:length(p)
      s=sprintf('%g  %gi',real(p(K)),imag(p(K)));
      listp(K)=cellstr(s);
	end;
   p=roots(B);
   if(isempty(p))
      listz={' '};
   else
	   for K=1:length(p)
	      s=sprintf('%g %gi',real(p(K)),imag(p(K)));
	      listz(K)=cellstr(s);
      end;
   end;
	set(hanaly(1),'String',listp);	
	set(hanaly(2),'String',listz);	
elseif(par==12)%to freq and damp
   global hanaly;
   global analy_mod;
   A=analy_mod.den;
   B=analy_mod.num;
   Ts=analy_mod.Ts;
   set(hanaly(3),'Value',0);
   [mag,w,xi]=ddamp(A,Ts);
   listp='';
   for K=1:length(mag)
      s=sprintf('f=%g  x=%g',w(K)/(2*pi),xi(K));
      listp(K)=cellstr(s);
	end;
   set(hanaly(1),'String',listp);
   listz='';
   if(length(B)>2)
	   [mag,w,xi]=ddamp(B,Ts);
	   for K=1:length(mag)
	      s=sprintf('f=%g  x=%g',w(K)/(2*pi),xi(K));
	      listz(K)=cellstr(s);
      end;
   else
      listz={' '};
   end;
   set(hanaly(2),'String',listz);	
   
elseif(par==13),
   global hanaly;
   global analy_mod;
   global xscal yscal;
   A=analy_mod.den;
   B=analy_mod.num;
   Ts=analy_mod.Ts;
   g=get(hanaly(6),'Value');
   if(g==1),%pole-zero map
		%pole-zero map
      axes(hanaly(7));
      hold off;
		p=roots(A);
		z=roots(B);
      hs(1)=plot(real(p),imag(p),'rx');
      hold on;
	   set(hs(1),'Markersize',8);
	   if(isempty(z)~=1)
	      hs(2)=plot(real(z),imag(z),'bo');
   	   set(hs(2),'Markersize',8);
	   else 
	      hs(2)=0;
      end;
      zgrid;
	   set(get(hanaly(7),'XLabel'),'String','Real');
	   set(get(hanaly(7),'YLabel'),'String','Imag');
	   set(hanaly(7),'XGrid','on','YGrid','on');
	   set(hanaly(7),'Fontsize',8);
	   set(hanaly(7),'Color',getfield(colorset,'Axes'));
   elseif(g==2),%frequency response - amplitude
      [s,f]=freqz(B,A,512,1/Ts);
      s=abs(s);
      axes(hanaly(7));
      hold off;
      sx='frequency [Hz]';
      sy='magnitude [-]';
      if (xscal==2), 
         f=2*pi*f;
      sx='frequency [rad/s]';         
      elseif(xscal==3), 
         f=f*Ts;
	      sx='frequency f/f_s[-]';         
      end;
      if (yscal==1), 
         for k=1:length(s), if s(k)<PREC, s(k)=PREC;end;end;         
         s=20*log10(s);
	      sy='magnitude [dB]';            
      end;
      plot(f,s,'r');
	   set(get(hanaly(7),'XLabel'),'String',sx);
	   set(get(hanaly(7),'YLabel'),'String',sy);
	   set(hanaly(7),'XGrid','on','YGrid','on');
	   set(hanaly(7),'Fontsize',8);
	elseif(g==3),%frequency response - phase
      [s,f]=freqz(B,A,512,1/Ts);
      s=angle(s);
      v=0;
      for k=1:length(s)-1,
         s2(k)=s(k)+v;
         if ((s(k)<0)&(s(k+1)>0))&( abs(s(k))+abs(s(k+1))>5.8), v=v-2*pi;
         elseif ((s(k)>0)&(s(k+1)<0))&( abs(s(k))+abs(s(k+1))>5.8), v=v+2*pi;
         end;
      end;
      s=[s2 s(length(s))+v];
      axes(hanaly(7));
      hold off;
      sx='frequency [Hz]';
      sy='magnitude [-]';
      if (xscal==2), 
         f=2*pi*f;
      sx='frequency [rad/s]';         
      elseif(xscal==3), 
         f=f*Ts;
	      sx='frequency f/f_s[-]';         
      end;
      sy='phase [rad]';            
      plot(f,s,'r');
	   set(get(hanaly(7),'XLabel'),'String',sx);
	   set(get(hanaly(7),'YLabel'),'String',sy);
	   set(hanaly(7),'XGrid','on','YGrid','on');
	   set(hanaly(7),'Fontsize',8);
   end;
   
elseif(par==30)%delete fcn
   clear global hanaly analy_mod;
elseif(par==31)%OK button
   global hanaly;
   close(hanaly(5));
end;
