function change(par)
%function to change parameters of system by sliders and popup
global PRECISION;
global colorset;
%handlers to objects
global h0 haxes_lu haxes_ld haxes_ru hpop_lu hpop_ru hpop_ld;
global hsli_dpf hdisp_dpf hsli_dpd hdisp_dpd;
global hsli_aux hdisp_aux hn_aux htxt_n;
global hsli_hsf hdisp_hsf htxt_hsf;
global hsli_hsd hdisp_hsd htxt_hsd;
global hsli_hrf hdisp_hrf htxt_hrf;
global hsli_hrd hdisp_hrd htxt_hrd;
global hpop_hs hpop_hr;
global hint hopn;

%variables
global PD PDfmin PDfmax PDdmin PDdmax;%polynom of dominant CL poles and ranges of freq and damp
global AP APgama APN APgmin APgmax;%structure about coeff. of aux. mult. pole
global Hs Hsfmin Hsfmax Hsdmin Hsdmax Hspmin Hspmax;
global Hr Hrfmin Hrfmax Hrdmin Hrdmax Hrpmin Hrpmax;
global Sypf_num Sypf_den Supf_num Supf_den; %numerators and denominators of 2poles/2zeros filters for Syp and Sup 
global Sypf Supf; %flags for the filters
global R S;
global Wsypu Wsypd Wsup Wsyb fn;
global Ts;
global A B;

global PAuxiliary;%structure for other auxiliary poles (oscillatory or multiple real)

%change graph
if(par==1) %graph left-down
   if(isempty(A)~=1)
      x=get(hpop_ld,'Value');
      dispgrap(haxes_ld,x);
   end;
elseif(par==2)%graph left-up
   if(isempty(A)~=1)
	   x=get(hpop_lu,'Value');
      dispgrap(haxes_lu,x);
   end;
elseif(par==3)%graph right-up
   if(isempty(A)~=1)
	   x=get(hpop_ru,'Value');
	   dispgrap(haxes_ru,x);
   end;
   
%------------------------------------------------- moving sliders    
elseif((par==11)|(par==12))%PD nat.freq,damp
   fnat=get(hsli_dpf,'Value');
   set(hdisp_dpf,'String',sprintf('%g ',fnat));
   xi=get(hsli_dpd,'Value');
   set(hdisp_dpd,'String',sprintf('%g ',xi));
   %transform continue->discret
   wnmin=2*pi*fnat;
	w=wnmin*Ts*sqrt(1-xi*xi);
	alpha=exp(-xi*wnmin*Ts);
	beta=cos(w);
	delta=sin(w);
	am1=-2*alpha*beta;
	am2=alpha*alpha;
   PD=[1 am1 am2]; %set default polynom of dom. poles
   rs_compute;
   %display graphs
   x=get(hpop_lu,'Value');
   dispgrap(haxes_lu,x);
   x=get(hpop_ld,'Value');
   dispgrap(haxes_ld,x);
   x=get(hpop_ru,'Value');
   dispgrap(haxes_ru,x);
   
elseif(par==13)%aux pole
   APgama=get(hsli_aux,'Value');
   set(hdisp_aux,'String',num2str(APgama));
   nmax=nmax_compute;   
   set(htxt_n,'String',sprintf('Free poles: %d',nmax));
   rs_compute;
   %display graphs
   x=get(hpop_lu,'Value');
   dispgrap(haxes_lu,x);
   x=get(hpop_ld,'Value');
   dispgrap(haxes_ld,x);
   x=get(hpop_ru,'Value');
   dispgrap(haxes_ru,x);
   
%movin Hs Hr
elseif((par==14)|(par==15))%Hs nat.freq and damping
   kind=get(hpop_hs,'Value');%1=1;2=1st order;3=2ndorder f,xi;
   if(kind==2)%1st order
      zer=get(hsli_hsd,'Value');
      if(abs(zer)<PRECISION) if(zer<0) zer=-1;else zer=1;end;zer=zer*0.0001;end;
		set(hsli_hsd,'Value',zer);      
      set(hdisp_hsd,'String',sprintf('%g',zer));
      Hs=[1 zer];
   else
	   fnat=get(hsli_hsf,'Value');
	   set(hdisp_hsf,'String',sprintf('%g ',fnat));
	   xi=get(hsli_hsd,'Value');
	   set(hdisp_hsd,'String',sprintf('%g ',xi));
	   %transform continue->discret
	   wnmin=2*pi*fnat;
		w=wnmin*Ts*sqrt(1-xi*xi);
		alpha=exp(-xi*wnmin*Ts);
		beta=cos(w);
		delta=sin(w);
		am1=-2*alpha*beta;
		am2=alpha*alpha;
      Hs=[1 am1 am2]; %set polynom
   end;
   if(get(hint,'Value')==1) Hs=conv(Hs,[1 -1]);end;%add integrator
   rs_compute;
   %display graphs
   x=get(hpop_lu,'Value');
   dispgrap(haxes_lu,x);
   x=get(hpop_ld,'Value');
   dispgrap(haxes_ld,x);
   x=get(hpop_ru,'Value');
   dispgrap(haxes_ru,x);
   
elseif((par==16)|(par==17))%Hr nat.freq and damping
   kind=get(hpop_hr,'Value');%1=1;2=1st order;3=2ndorder f,xi;
   if(kind==2)%1st order
      zer=get(hsli_hrd,'Value');
      if(abs(zer)<PRECISION) if(zer<0) zer=-1;else zer=1;end;zer=zer*0.0001;end;
		set(hsli_hrd,'Value',zer);      
      set(hdisp_hrd,'String',sprintf('%g',zer));
      Hr=[1 zer];
   else%2nd order
      fnat=get(hsli_hrf,'Value');
	   set(hdisp_hrf,'String',sprintf('%g ',fnat));
	   xi=get(hsli_hrd,'Value');
	   set(hdisp_hrd,'String',sprintf('%g ',xi));
	   %transform continue->discret
	   wnmin=2*pi*fnat;
		w=wnmin*Ts*sqrt(1-xi*xi);
		alpha=exp(-xi*wnmin*Ts);
		beta=cos(w);
		delta=sin(w);
		am1=-2*alpha*beta;
		am2=alpha*alpha;
	   Hr=[1 am1 am2]; %set polynom
   end;
   rs_compute;
   %display graphs
   x=get(hpop_lu,'Value');
   dispgrap(haxes_lu,x);
   x=get(hpop_ld,'Value');
   dispgrap(haxes_ld,x);
   x=get(hpop_ru,'Value');
   dispgrap(haxes_ru,x);
   
elseif(par==18), %changing order of multiple pole "-"
   curr_n=str2num(get(hn_aux,'string'));
   if curr_n>0,
      set(hn_aux,'string',curr_n-1);
	   APN=curr_n-1;
	   rs_compute;
	   nmax=nmax_compute;   
	   set(htxt_n,'String',sprintf('Free poles: %d',nmax));
   	%display graphs
	   x=get(hpop_lu,'Value');
	   dispgrap(haxes_lu,x);
	   x=get(hpop_ld,'Value');
	   dispgrap(haxes_ld,x);
	   x=get(hpop_ru,'Value');
      dispgrap(haxes_ru,x);
   end;
   
elseif(par==19), %changing order of multiple pole "+"
   global hn_aux;
   n_max=nmax_compute;
   if n_max>0,
      curr_n=str2num(get(hn_aux,'string'));
      set(hn_aux,'string',curr_n+1);
	   APN=curr_n+1;
	   rs_compute;
	   nmax=nmax_compute;   
	   set(htxt_n,'String',sprintf('Free poles: %d',nmax));
	   %display graphs
	   x=get(hpop_lu,'Value');
	   dispgrap(haxes_lu,x);
	   x=get(hpop_ld,'Value');
	   dispgrap(haxes_ld,x);
	   x=get(hpop_ru,'Value');
	   dispgrap(haxes_ru,x);
   end;   
   
elseif(par==20), %analyse model
   analym(1,B,A,Ts,'Model Analysis');
   
elseif(par==21), %analyse controller
   [rr,ss,Paux]=rs_complete;
   analym(1,rr,ss,Ts,'Controller Analysis');   
   
elseif(par==22), %analyse CL
   global T;
   if isempty(T) Tt=1;else Tt=T;end;
   [rr,ss,Paux]=rs_complete;
   den=conv(A,ss) + conv(B,rr);
   num=conv(B,Tt);
	analym(1,num,den,Ts,'Closed Loop Analysis');   
   
%popup Hr Hs   
elseif(par==51)|(par==511)%Hs popup
   kind=get(hpop_hs,'Value');%1=1;2=1st order;3=2ndorder f,xi;
   nmax=nmax_compute;
   ni=get(hint,'Value');
   lh=length(Hs)-1;
   if lh-ni-kind+1>nmax,%(lh-kind)>nmax,
      warndlg('Can not performe, remove some of auxiliary poles first!');
      set(hpop_hs,'Value',(lh-ni)+1);
      return;
   end;
   
   if(kind==1)%1
      if(par~=511)
	      set(hsli_hsd,'Enable','off');
	      set(hsli_hsf,'Enable','off');
	      set(hdisp_hsd,'String','- ');
         set(hdisp_hsf,'String','- ');
      end;
      Hs=1;
   elseif(kind==2)%1st order
      if(par~=511)
	      set(hsli_hsf,'Enable','off');
	      set(hdisp_hsf,'String','- ');
         delete(hsli_hsd);
			hsli_hsd = uicontrol('Parent',h0, ...
				'Units','points', ...
				'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
			   'ListboxTop',0, ...
			   'Enable','on', ...
				'Position',[439.5 78 129 15.75], ...
	         'Style','slider', ...
	         'Max',Hspmax, ...
	         'Min',Hspmin, ...
	         'Value',((Hspmax-Hspmin)/2)+Hspmin, ...
			   'Callback','change(15);',...   
			   'Tag','slid_hrd');
         set(htxt_hsd,'String','Coeff');
         koef=((Hspmax-Hspmin)/2)+Hspmin;
	      set(hdisp_hsd,'String',sprintf('%g',((Hspmax-Hspmin)/2)+Hspmin));
      else
         koef=get(hsli_hsd,'Value');
      end;
      if(abs(koef)<PRECISION) if(koef<0) koef=-1;else koef=1;end;koef=koef*0.0001;end;
      Hs=[1 koef];
   elseif(kind==3)%2nd order
      if(par~=511)
	      set(hsli_hsd,'Max',Hsdmax,'Min',Hsdmin,'Value',((Hsdmax-Hsdmin)/2)+Hsdmin,'Enable','on');
		   set(hsli_hsf,'Enable','on');
         set(htxt_hsd,'String','Damping');
      end;
	   fnat=get(hsli_hsf,'Value');
      set(hdisp_hsf,'String',sprintf('%g ',fnat));
      xi=get(hsli_hsd,'Value');
      set(hdisp_hsd,'String',sprintf('%g ',xi));
	   %transform continue->discret
	   wnmin=2*pi*fnat;
		w=wnmin*Ts*sqrt(1-xi*xi);
		alpha=exp(-xi*wnmin*Ts);
		beta=cos(w);
		delta=sin(w);
		am1=-2*alpha*beta;
      am2=alpha*alpha;
      Hs=[1 am1 am2]; %set polynom
   end;
   if(get(hint,'Value')==1) Hs=conv(Hs,[1 -1]);end;%add integrator
   %recomuting the order of aux. poles and the polynom because order Hs is changed
   rs_compute;
   nmax=nmax_compute;
   set(htxt_n,'String',sprintf('Free poles: %d',nmax));   
   %display graphs
   x=get(hpop_lu,'Value');
   dispgrap(haxes_lu,x);
   x=get(hpop_ld,'Value');
   dispgrap(haxes_ld,x);
   x=get(hpop_ru,'Value');
   dispgrap(haxes_ru,x);
   
elseif(par==52)%Hr popup
   kind=get(hpop_hr,'Value'); %1=1;2=1st order;3=2ndorder f,xi;
   nmax=nmax_compute;
   lh=length(Hr)-1;   
   no=get(hopn,'Value');
   if (lh-no-kind+1)>nmax,
      warndlg('Can not performe, remove some of auxiliary poles first!');
      set(hpop_hr,'Value',lh-no+1);
      return;
   end;
   if(kind==1)%1
      set(hsli_hrd,'Enable','off');
      set(hsli_hrf,'Enable','off');
      set(hdisp_hrd,'String','- ');
      set(hdisp_hrf,'String','- ');
      Hr=1;
   elseif(kind==2)%1st
      set(hsli_hrf,'Enable','off');
      set(hdisp_hrf,'String','- ');
      delete(hsli_hrd);
		hsli_hrd = uicontrol('Parent',h0, ...
			'Units','points', ...
			'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
		   'ListboxTop',0, ...
		   'Enable','on', ...
			'Position',[439.5 26.25 129 15.75], ...
         'Style','slider', ...
         'Max',Hrpmax, ...
         'Min',Hrpmin, ...
         'Value',((Hrpmax-Hrpmin)/2)+Hrpmin, ...
		   'Callback','change(17);',...   
		   'Tag','slid_hrd');
      set(hdisp_hrd,'String',sprintf('%g',((Hrpmax-Hrpmin)/2)+Hrpmin));
      set(htxt_hrd,'String','Coeff');
      koef=((Hrpmax-Hrpmin)/2)+Hrpmin;
      if(abs(koef)<PRECISION) if(koef<0) koef=-1;else koef=1;end;koef=koef*0.0001;end;
      Hr=[1 koef];
   elseif(kind==3)%2nd order
      set(hsli_hrf,'Enable','on');
      fnat=get(hsli_hrf,'Value');
      set(hdisp_hrf,'String',sprintf('%g',fnat));
      xi=((Hrdmax-Hrdmin)/2)+Hrdmin;
		delete(hsli_hrd);      
		hsli_hrd = uicontrol('Parent',h0, ...
			'Units','points', ...
			'BackgroundColor',[0.752941176470588 0.752941176470588 0.752941176470588], ...
		   'ListboxTop',0, ...
		   'Enable','on', ...
			'Position',[439.5 26.25 129 15.75], ...
         'Style','slider', ...
         'Max',Hrdmax, ...
         'Min',Hrdmin, ...
         'Value',xi, ...
		   'Callback','change(17);',...   
		   'Tag','slid_hrd');
      set(hdisp_hrd,'String',sprintf('%g',xi));
      set(htxt_hrd,'String','Damping');
	   %transform continue->discret
	   wnmin=2*pi*fnat+fnat*0.013;
		w=wnmin*Ts*sqrt(1-xi*xi);
		alpha=exp(-xi*wnmin*Ts);
		beta=cos(w);
		delta=sin(w);
		am1=-2*alpha*beta;
		am2=alpha*alpha;
      Hr=[1 am1 am2]; %set polynom
   end;
   %recomuting the order of aux. poles and the polynom because order Hr is changed
   nmax=nmax_compute;   
   set(htxt_n,'String',sprintf('Free poles: %d',nmax));   
   rs_compute;
   %display graphs
   x=get(hpop_lu,'Value');
   dispgrap(haxes_lu,x);
   x=get(hpop_ld,'Value');
   dispgrap(haxes_ld,x);
   x=get(hpop_ru,'Value');
   dispgrap(haxes_ru,x);
   
elseif(par==53) %set/reset Sup filter
   global Supf;
	global hchk_syp hchk_sup;%checkboxes for Syp and Sup filters
   if Supf==1, Supf=0; else Supf=1; end;
   set(hchk_sup,'value',Supf);
   rs_compute;
   %display graphs
   x=get(hpop_lu,'Value');
   dispgrap(haxes_lu,x);
   x=get(hpop_ld,'Value');
   dispgrap(haxes_ld,x);
   x=get(hpop_ru,'Value');
   dispgrap(haxes_ru,x);
   
elseif(par==54) %set/reset Syp filter
   global Sypf;
	global hchk_syp hchk_sup;%checkboxes for Syp and Sup filters
   if Sypf==1, Sypf=0;else Sypf=1;end;
   set(hchk_syp,'value',Sypf);
   rs_compute;
   %display graphs
   x=get(hpop_lu,'Value');
   dispgrap(haxes_lu,x);
   x=get(hpop_ld,'Value');
   dispgrap(haxes_ld,x);
   x=get(hpop_ru,'Value');
   dispgrap(haxes_ru,x);
   
elseif(par==55), %add/remove loop opening at 0.5fs
   o=get(hopn,'Value');
   if o==1,%open loop
      Hr=conv(Hr,[1 1]);
   elseif o==0,
      r=roots(Hr);
      r2=[];
      for k=1:length(r),
         if (real(r(k))+1)<PRECISION & abs(imag(r(k)))<PRECISION,  else r2=[r2;r(k)];end;
      end;
      if ~isempty(r2),Hr=poly(r2);else Hr=1;end;
   end;
   %recomuting the order of aux. poles and the polynom because order Hr is changed
   nmax=nmax_compute;   
   set(htxt_n,'String',sprintf('Free poles: %d',nmax));   
   rs_compute;
   %display graphs
   x=get(hpop_lu,'Value');
   dispgrap(haxes_lu,x);
   x=get(hpop_ld,'Value');
   dispgrap(haxes_ld,x);
   x=get(hpop_ru,'Value');
   dispgrap(haxes_ru,x);
   
elseif(par==60)%hold graphs
	global hbut_hld;
   s=get(hbut_hld,'String');
   if(strcmp(s,'Hold graphs'))%hold current graphs
	   set(hbut_hld,'String','Release graphs');
      %save current set of parameters
	   if Supf, Rr=conv(R,conv(Hr,Supf_num));else Rr=conv(R,Hr);end;
	   if Sypf, Sr=conv(S,conv(Hs,Sypf_num));else Sr=conv(S,Hs);end;
      global savehld;
      savehld=struct('on',1,'R',Rr,'S',Sr,'Hs',1,'Hr',1,'AP',AP);
	   %display graphs
	   x=get(hpop_lu,'Value');
	   disphld(haxes_lu,x);
	   x=get(hpop_ld,'Value');
	   disphld(haxes_ld,x);
	   x=get(hpop_ru,'Value');
	   disphld(haxes_ru,x);
	elseif(strcmp(s,'Release graphs'))%release it
      global savehld;
      savehld=struct('on',0);
	   set(hbut_hld,'String','Hold graphs');
      x=get(hpop_lu,'Value');
      set(haxes_lu,'UserData',[]);
	   dispgrap(haxes_lu,x);
      x=get(hpop_ld,'Value');
      set(haxes_ld,'UserData',[]);
	   dispgrap(haxes_ld,x);
      x=get(hpop_ru,'Value');
      set(haxes_ru,'UserData',[]);
	   dispgrap(haxes_ru,x);
   end;
elseif(par==81)%point cursor on
	set(h0,'Units','points');
	set(h0,'WindowButtondownfcn','pcursor(1);');
	set(h0,'WindowButtonupfcn','pcursor(2);');
elseif(par==82)%zoom
   global A B;
   if isempty(A)|isempty(B) return;end;
   zoom on;
   
elseif(par==83)%figure
   global A B;
   if isempty(A)|isempty(B) return;end;
   global h0;
   set(h0,'Unit','pixel');
   pmain=get(h0,'Position');
   set(h0,'Unit','point');
   
	ped=[569 355 235 144];
	ped(1)=pmain(1)+(pmain(3)-ped(3))/2;
	ped(2)=pmain(2)+(pmain(4)-ped(4))/2;
hx = dialog('Color',getfield(colorset,'Background'), ...
	'MenuBar','none', ...
	'Position',ped, ...
   'Resize','off', ...
   'name','Figure creator', ...
   'DeleteFcn','printfig(3);', ...
	'Tag','Fig1');
hchb_lu = uicontrol('Parent',hx, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[18 54 51.75 15], ...
	'String','Left-Up', ...
	'Style','checkbox', ...
	'Tag','chb1');
hchb_ru = uicontrol('Parent',hx, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[96.75 54 61.5 15], ...
	'String','Right-Up', ...
	'Style','checkbox', ...
	'Tag','chb2');
hchb_ld = uicontrol('Parent',hx, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[18 32.25 61.5 15], ...
	'String','Left-Down', ...
	'Style','checkbox', ...
	'Tag','chb3');
h1 = uicontrol('Parent',hx, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontSize',10, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[18 81.75 140.25 15], ...
	'String','Available Graphs', ...
	'Style','text', ...
	'Tag','StaticText1');
h1 = uicontrol('Parent',hx, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[96.75 8.25 45 15], ...
   'String','OK', ...
   'Callback','printfig(1);', ...
	'Tag','Pushbutton1');
h1 = uicontrol('Parent',hx, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[37.5 8.25 45 15], ...
   'String','Cancel', ...
   'Callback','printfig(2);', ...
	'Tag','Pushbutton2');
	global hfig;
	hfig=[hx hchb_lu hchb_ru hchb_ld];
end;
