function hlp(par)
global colorset;
%colorder=[[0 0 1];[0 0.5 0];[1 0 0];[0 0.75 0.75];[0.75 0 0.75];[0.75 0.75 0];[0.25 0.25 0.25]];

if(par==1)%theory
   global h0;
   set(h0,'Unit','pixel');
   pmain=get(h0,'Position');
   set(h0,'Unit','point');
   ped=[23 28 800 600];
   ped(1)=pmain(1)+(pmain(3)-ped(3))/2;
   ped(2)=pmain(2)+(pmain(4)-ped(4))/2;
   
hh = figure('Color',getfield(colorset,'Background'), ...
	'MenuBar','none', ...
	'Name','Theory - Pole Placement', ...
	'Position',ped, ...
   'Resize','off', ...
   'Deletefcn','hlp(3);', ...
	'Tag','Fig1');
h1 = axes('Parent',hh, ...
	'Color',getfield(colorset,'Background'), ...
	'Units','pixels', ...
	'Box','on', ...
	'CameraUpVector',[0 1 0], ...
	'Color',getfield(colorset,'Background'), ...
	'Position',[33 202 739 387], ...
	'Tag','Axes1', ...
	'XColor',[0 0 0], ...
	'XTickMode','manual', ...
	'YColor',[0 0 0], ...
	'YLimMode','manual', ...
	'YTickMode','manual', ...
   'ZColor',[0 0 0]);
hax=h1;
h1 = axes('Parent',hh, ...
	'Units','pixels', ...
	'CameraUpVector',[0 1 0], ...
	'CLimMode','manual', ...
	'Color',getfield(colorset,'Background'), ...
	'Position',[35 38 739 158], ...
	'Tag','Axes2', ...
	'XColor',[0 0 0], ...
	'XTick',[], ...
	'XTickMode','manual', ...
   'YColor',[0 0 0], ...
	'YTickMode','manual', ...
   'ZColor',[0 0 0]);
hax2=h1;
h1 = uicontrol('Parent',hh, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[278.25 7.5 45 15], ...
   'String','OK', ...
   'CallBack','close;', ...
   'Tag','Pushbutton1');
h1 = uicontrol('Parent',hh, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[540.75 7.5 45 15], ...
   'String','2nd page', ...
   'Callback','close;hlp(12);', ...
	'Tag','Pushbutton2');


global map;
[im,nmap]=imread('b256.pcx','pcx');
map=colormap;
nmap(2,:)=[1 1 1];
colormap(nmap);
axes(hax);
image(im);

%clear im map nmap;
set(hax,'XTick',[]);
set(hax,'YTick',[]);

[im,nmap]=imread('theory1.pcx','pcx');
axes(hax2);
image(im);

set(hax2,'XTick',[]);
set(hax2,'YTick',[]);

elseif(par==2)%about aplication
   d1=sprintf('This toolbox concerns design of pole-placement based controllers and it was ');
   d2=sprintf('developed in Laboratoire d''Automatique de Grenoble ');
   d3=sprintf('as a part of doctoral thesis. The principal reference for the ');
   d4=sprintf('toolbox is "Prochazka, H. Landau, I.D.(2002) Logiciel pour l''enseignement et le calcul du placement ');
   d5=sprintf('de ples robust, Conf.Int.Francophone, Nante". ');
   d6=sprintf('For theory see Landau,I.D.(2002) Commande des systmes, Herms, Paris" or "Prochazka H.,');
   d7=sprintf('Landau, I.D.(2003) Pole placement with sensitivity shaping using 2nd order digital notch filters, Automatica, 39(6)"');

   
   description=[d1 d2 d3 d4 d5 d6 d7];
   d1=sprintf('Product name:\t Pole Placement Master');
   d2=sprintf('\nVersion:\t 2.0');
   d3=sprintf('\nTheory:\t Ioan Dore Landau, Hynek Prochazka');   
   d4=sprintf('\nProgrammer:\t Hynek Prochazka');
   d5=sprintf('\nUniversity:\t INPG - LAG, Grenoble, FRANCE');
   property=[d1,d2,d3,d4,d5];
   
   global h0;
   set(h0,'Unit','pixel');
   pmain=get(h0,'Position');
   set(h0,'Unit','point');
   ped=[232 470 560 238];
   ped(1)=pmain(1)+(pmain(3)-ped(3))/2;
   ped(2)=pmain(2)+(pmain(4)-ped(4))/2;
hd = dialog('Color',getfield(colorset,'Background'), ...
	'MenuBar','none', ...
	'Position',ped, ...
   'Resize','off', ...
   'Name','About Aplication', ...
	'Tag','Fig1');
h1 = uicontrol('Parent',hd, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontName','Times New Roman', ...
	'FontSize',16, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[119.25 147 183 24], ...
	'String','Pole Placement Master', ...
	'Style','text', ...
	'Tag','head');%76.5
h1 = uicontrol('Parent',hd, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontName','Helvetica', ...
	'FontSize',8, ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[14.25 80 393.75 70], ...
	'String',description, ...
	'Style','text', ...
	'Tag','descript');%16.5;56.25
h1 = uicontrol('Parent',hd, ...
	'Units','points', ...
	'BackgroundColor',getfield(colorset,'Background'), ...
	'FontName','Times New Roman', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[14.25 10 301.5 75], ...
	'String',property, ...
	'Style','text', ...
	'Tag','property');
h1 = uicontrol('Parent',hd, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[363 16.5 45 15], ...
   'String','OK', ...
   'Callback','close;', ...
	'Tag','Pushbutton1');
elseif(par==3)%deletefcn theory
   global map; 
   colormap(map);
   clear global map;   
elseif(par==12)%page 2
   
   global h0;
   set(h0,'Unit','pixel');
   pmain=get(h0,'Position');
   set(h0,'Unit','point');
   ped=[23 28 800 600];
   ped(1)=pmain(1)+(pmain(3)-ped(3))/2;
   ped(2)=pmain(2)+(pmain(4)-ped(4))/2;
hh = figure('Color',getfield(colorset,'Background'), ...
	'MenuBar','none', ...
	'Name','Theory - Calibrating of Sensitivity Functions', ...
	'Position',ped, ...
   'Resize','off', ...
   'deletefcn','hlp(3);', ...
   'Tag','Fig1');

h1 = axes('Parent',hh, ...
	'Units','pixels', ...
	'CameraUpVector',[0 1 0], ...
	'Color',[1 1 1], ...
	'Position',[17 40 769 549], ...
	'Tag','Axes1', ...
	'XColor',[0 0 0], ...
	'YColor',[0 0 0], ...
   'ZColor',[0 0 0]);
hax_th2=h1;

h1 = uicontrol('Parent',hh, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[278.25 7.5 45 15], ...
   'String','OK', ...
   'CallBack','close;', ...
   'Tag','Pushbutton1');
h1 = uicontrol('Parent',hh, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[20 7.5 45 15], ...
   'String','1st page', ...
   'Callback','close;hlp(1);', ...
   'Tag','Pushbutton2');

[im,nmap]=imread('theory2.pcx','pcx');
nmap(2,:)=[1 1 1];
colormap(nmap);

axes(hax_th2);
image(im);

set(hax_th2,'XTick',[]);
set(hax_th2,'YTick',[]);


end;
