%function for loading models in WinPim format

function [A,B,C,na,nb,d,nc,midf]=loadwp(file);

%A...vector of coeficients of A polynom
%B...vector of coeficients of B polynom
%C...vector of coeficients of C polynom
%na...degree of polynom A
%nb...degree of polynom B
%nc...degree of polynom C
%d... pure delay of the model
%midf...i.d. number of (simulation) method 

%file... name of the file with model
global Ts;

filein=fopen(file,'rt');
if(filein==-1) 
   disp('Opening file was not successfull');
   A=[];B=[];C=[];na=0;nb=0;nc=0;d=0;midf=0;
   return;
end;
   
% reading of head
na=fscanf(filein,'%d',1);
c=fread(filein,1);
while c>=13, c=fread(filein,1);end;

nb=fscanf(filein,'%d',1); 
c=fread(filein,1);
while c>=13, c=fread(filein,1);end;

nc=fscanf(filein,'%d',1); 
c=fread(filein,1);
while c>=13, c=fread(filein,1);end;

fscanf(filein,'%d',1); 
c=fread(filein,1);
while c>=13, c=fread(filein,1);end;

midf=fscanf(filein,'%d',1); 
c=fread(filein,1);
while c>=13, c=fread(filein,1);end;

d=fscanf(filein,'%d',1); 
c=fread(filein,1);
while c>=13, c=fread(filein,1);end;

% reading of A
if (na>0),
   A=1:na+1;
   A(1)=1.0;
   for i=2:na+1,
      A(i)=fscanf(filein,'%lg',1); 
      c=fread(filein,1);
      while c>=13, c=fread(filein,1);end;
   end;
end;   

% reading B
if (nb>0),
   B=1:nb+d+1;
   % delay of B and coeff b0
   for i=1:d+1 B(i)=0; end;
   for k=d+2:nb+d+1
      B(k)=fscanf(filein,'%lg',1);
      c=fread(filein,1);
      while c>=13, c=fread(filein,1);end;
   end;
else
   B=0;
end;

% reading C
if(nc>0),
   C=1:nc+1;
   C(1)=0;
   for i=2:nc+1,
      C(i)=fscanf(filein,'%lg',1); 
      c=fread(filein,1);
      while c>=13, c=fread(filein,1);end;
   end;
else
   C=0;
end;
c=fread(filein,1);
while c>=13, c=fread(filein,1);end;%skiping ***
c=fread(filein,1);
while c>=13, c=fread(filein,1);end;%skiping samples
%reading sampling time
Ts=fscanf(filein,'%g',1); 

fclose(filein);
%-----------------------------transormation from TF(z^-1) to TF(z)
%A(z^-1)=a0+a1z^-1+ ... aNaz^-Na ---> A(z)=a0z^Na2 + ...
nBd=nb+d;
if(na>nBd)%polynom A has higher order
   A=A;%nothing to change
   zr=zeros(1,na-nBd);
   B=[B zr];%increase order of B
elseif(nBd>na)
   B=B;%nothing to change
   zr=zeros(1,nBd-na);
   A=[A zr];%increase order of A
end;
%adjust length of polynoms
if(length(B)<length(A))
   zr=zeros(1,length(A)-length(B));
   B=[zr B];
elseif(length(B)>length(A))
   zr=zeros(1,length(B)-length(A));
   A=[zr A];
end;

   
