function t_dishld(hand,par)
%function to display held graphs of the tracking part
global colorset;
global A B;
global Ts;
global savehld;

%savehld=struct('on',1,'R',R,'S',S,'Hs',Hs,'Hr',Hr,'AP',AP,'Am',Am,'Bm',Bm,'cascad',cascad,'T',T);

global h0;
global savehld;

K=getfield(savehld,'on');
if(K==0) return;end;

R=getfield(savehld,'R');
S=getfield(savehld,'S');
Hs=getfield(savehld,'Hs');
Hr=getfield(savehld,'Hr');
AP=getfield(savehld,'AP');
Am=getfield(savehld,'Am');
Bm=getfield(savehld,'Bm');
cascad=getfield(savehld,'cascad');
T=getfield(savehld,'T');


if(isempty(A)|isempty(B)|isempty(R)|isempty(S)|isempty(T)) return; end;

%reference signal
den=1;
num=1;
for K=1:cascad
	den=conv(den,Am);
	num=conv(num,Bm);
end;
sys=tf(num,den,Ts);
global hed_tmax;
tmax=str2num(get(hed_tmax,'String'));
if(isempty(tmax)|tmax<=0|tmax>1000)
   tmax=9/(2*pi*0.05/Ts);
   s=sprintf('%g',tmax);
   set(hed_tmax,'String',s);
end;

[ref,tim]=step(sys,tmax);

if(par==1)
	ss=conv(S,Hs);
	rr=conv(R,Hr);
	den=add(conv(A,ss),conv(B,rr));
	num=conv(B,T);
	resp=filter(num,den,ref);
elseif(par==2)
   resp=ref;
elseif(par==3)
	ss=conv(S,Hs);
	rr=conv(R,Hr);
	den=add(conv(A,ss),conv(B,rr));
	num=conv(A,T);
	resp=filter(num,den,ref);
end;

line('Color',getfield(colorset,'Held'), ...
	'LineStyle','--', ...
	'LineWidth',[0.5], ...
   'Marker','none', ...
	'XData',tim, ...
	'YData',resp,...
   'Parent',[hand]);
