function filter_w2(par);

global PRECISION;
PREC=PRECISION;
global colorset;
if par==0, %initialization of window 
   global filter_var;
   global A B PD AP Hr Hs Ts Wsup Wsypu fn Ts;
   global Sup_filters Syp_filters;
   global PAuxiliary;
   
   paux=evalaux(PAuxiliary);
   paux=conv(AP,paux);
   
   filter_var=struct('minatt',-100,'maxatt',10,'minfreq',PREC,'maxfreq',1/(2*Ts),'mindamp',0.01,'maxdamp',1, ...
      'A',A,'B',B,'Hr',Hr,'Hs',Hs,'PD',PD,'AP',paux,'Ts', Ts, ...
      'Wsup',Wsup,'Wsyp',Wsypu,'Wfn',fn/Ts,'fsup',Sup_filters,'fsyp',Syp_filters, ...
      'hfilt',[],'hsfun',[],'hsfun2',[], 'hfposup',[],'hfposyp',[], ...
      'active',0);
   filter_var.active=1; %Syp is active (=2 => Sup is active)
   filterwin2;
   
elseif par==1, %OK button
   global filter_var;
	global hvec_filter;   
   %compute filters
   %Syp
   vecfilter=filter_var.fsyp;
   sypnum=1;
   sypden=1;
   if ~isempty(vecfilter),
	   for k=1:length(vecfilter), 
		   [num,den,om_n,xi_n,om_d,xi_d]=filter22(vecfilter(k).Mt,vecfilter(k).ft,vecfilter(k).xin,filter_var.Ts);
	      sypnum=conv(sypnum,num);
	      sypden=conv(sypden,den);
      end;
   end;
   %Sup
   vecfilter=filter_var.fsup;
   supnum=1;
   supden=1;
   if ~isempty(vecfilter),
	   for k=1:length(vecfilter), 
		   [num,den,om_n,xi_n,om_d,xi_d]=filter22(vecfilter(k).Mt,vecfilter(k).ft,vecfilter(k).xin,filter_var.Ts);
	      supnum=conv(supnum,num);
	      supden=conv(supden,den);
      end;
   end;
   global Sypf_num Sypf_den Supf_num Supf_den; %numerators and denominators of 2poles/2zeros filters for Syp and Sup 
   global Sup_filters Syp_filters;
   Sypf_num=sypnum;Sypf_den=sypden;
   Supf_num=supnum;Supf_den=supden;
   Syp_filters=filter_var.fsyp;
   Sup_filters=filter_var.fsup;
   close(hvec_filter(1));
   change(11); %recompute the functions
   
elseif par==2, %Cancel button
	global hvec_filter;   
	close(hvec_filter(1));   
  
elseif par==3, %deletefcn
   global filter_var;
	global hvec_filter;   
   clear filter_var hvec_filter;   
   
elseif par==4, %init for filter window/changing of active functions
   global hvec_filter;
%hvec_filter=[h0 hax_flt hax_syp hax_sup hsld_att hsld_frq hsld_dmp htxt_att htxt_frq htxt_dmp ...
%      		htxt_num htxt_den hrad_syp hrad_sup htxt_flt hlst_flt];
	global filter_var;
   if filter_var.active==1, %Syp
      vecfilter=filter_var.fsyp;
	   set(hvec_filter(13),'value',1);
	   set(hvec_filter(14),'value',0);
   elseif filter_var.active==2, %Sup
      vecfilter=filter_var.fsup;
	   set(hvec_filter(13),'value',0);
	   set(hvec_filter(14),'value',1);
   end;
   if isempty(vecfilter), %disable slides and list
      set(hvec_filter(5),'enable','off');
		set(hvec_filter(8),'String','-');
      set(hvec_filter(6),'enable','off');      
      set(hvec_filter(9),'String','-');  
      set(hvec_filter(18),'String','-');
      set(hvec_filter(7),'enable','off');
      set(hvec_filter(10),'String','-');      
		set(hvec_filter(11),'String','-');      
      set(hvec_filter(12),'String','-');      
		set(hvec_filter(17),'String','-');      
      set(hvec_filter(16),'enable','off','string','-','value',1);
      if ~isempty(get(hvec_filter(2),'children')), 
         delete(get(hvec_filter(2),'children'));
         filter_var.hfilt=[];
      end;%erase curve
   else %display filters
      listp={};
	   for K=1:length(vecfilter),
	      s=sprintf('f%d : %gHz, %gdB, %g',K,vecfilter(K).ft,vecfilter(K).Mt,vecfilter(K).xin);
	      listp(K)=cellstr(s);
      end;
		val=(vecfilter(1).Mt-filter_var.minatt)/(filter_var.maxatt-filter_var.minatt);
      set(hvec_filter(5),'enable','on','value',val);
		set(hvec_filter(8),'String',num2str(vecfilter(1).Mt));
		val=(vecfilter(1).ft-filter_var.minfreq)/(filter_var.maxfreq-filter_var.minfreq);
      set(hvec_filter(6),'enable','on','value',val);      
      set(hvec_filter(9),'String',sprintf('%g',vecfilter(1).ft));      
	   set(hvec_filter(18),'String',sprintf('%grad/s',2*pi*vecfilter(1).ft));
		val=(vecfilter(1).xin-filter_var.mindamp)/(filter_var.maxdamp-filter_var.mindamp);      
      set(hvec_filter(7),'enable','on','value',val);
      set(hvec_filter(10),'String',num2str(vecfilter(1).xin));      
      set(hvec_filter(17),'String',sprintf('num.damp.:%g',vecfilter(1).xin*10^(vecfilter(1).Mt/20)));%analog numerator damping
      set(hvec_filter(16),'string',listp,'value',1,'enable','on');
	   %compute filter
	   [num,den,om_n,xi_n,om_d,xi_d]=filter22(vecfilter(1).Mt,vecfilter(1).ft,vecfilter(1).xin,filter_var.Ts);
   	%display zeros
	   snum=sprintf('fn =%gHz(%grad/s), xi =%g',om_n/(2*pi),om_n,xi_n);
	   sden=sprintf('fn =%gHz(%grad/s), xi =%g',om_d/(2*pi),om_d,xi_d);
	   set(hvec_filter(11),'String',snum);
	   set(hvec_filter(12),'String',sden);   
	   %display graphs
	   [s,f]=freqz(num,den,512,1/filter_var.Ts);
	   for k=1:length(s), if abs(s)<PREC, s=1e-6;end;end;
	   axes(hvec_filter(2));
	   hold off;
      filter_var.hfilt=plot(f,20*log10(abs(s)),'r');
      title('Filter Magnitude');
	end;
   filter_w2(6); %redraw sensitivity functions         

   
elseif(par==5)%recompute current filter
   global hvec_filter;
%hvec_filter=[h0 hax_flt hax_syp hax_sup hsld_att hsld_frq hsld_dmp htxt_att htxt_frq htxt_dmp ...
%      		htxt_num htxt_den hrad_syp hrad_sup htxt_flt hlst_flt];
   global filter_var;
   %read slides
   attenuation=(filter_var.maxatt-filter_var.minatt)*get(hvec_filter(5),'Value') + filter_var.minatt;
  	set(hvec_filter(8),'String',num2str(attenuation));
   frequency=(filter_var.maxfreq-filter_var.minfreq)*get(hvec_filter(6),'Value') + filter_var.minfreq;
   set(hvec_filter(9),'String',sprintf('%g',frequency));
   set(hvec_filter(18),'String',sprintf('%grad/s',2*pi*frequency));
   damping=(filter_var.maxdamp-filter_var.mindamp)*get(hvec_filter(7),'Value') + filter_var.mindamp;
   set(hvec_filter(10),'String',num2str(damping));
	set(hvec_filter(17),'String',sprintf('num.damp.:%g',damping*10^(attenuation/20)));
   %compute filter
   [num,den,om_n,xi_n,om_d,xi_d]=filter22(attenuation,frequency,damping,filter_var.Ts);
   %display zeros
   snum=sprintf('fn =%gHz(%grad/s), xi =%g',om_n/(2*pi),om_n,xi_n);
   sden=sprintf('fn =%gHz(%grad/s), xi =%g ',om_d/(2*pi),om_d,xi_d);
   set(hvec_filter(11),'String',snum);
   set(hvec_filter(12),'String',sden);   
   %display graphs
   [s,f]=freqz(num,den,512,1/filter_var.Ts);
   for k=1:length(s), if abs(s(k))<PREC, s(k)=PREC;end;end;
   if isempty(filter_var.hfilt),
      axes(hvec_filter(2));
      filter_var.hfilt=plot(f,20*log10(abs(s)),'r');
      title('Filter Magnitude');
   else
		set(filter_var.hfilt,'YData',20*log10(abs(s)));
   end;
   %store filter
   index=get(hvec_filter(16),'value');
   if filter_var.active==1, %Syp
      vecfilter=filter_var.fsyp;
      filtn=struct('ft',frequency,'Mt',attenuation,'xin',damping);
      vecfilter(index)=filtn;
      filter_var.fsyp=vecfilter;
   elseif filter_var.active==2, %Syp
      vecfilter=filter_var.fsup;
      filtn=struct('ft',frequency,'Mt',attenuation,'xin',damping);
      vecfilter(index)=filtn;
      filter_var.fsup=vecfilter;
   end;
   listp={};
   for K=1:length(vecfilter),
      s=sprintf('f%d : %gHz, %gdB, %g',K,vecfilter(K).ft,vecfilter(K).Mt,vecfilter(K).xin);
      listp(K)=cellstr(s);
   end;
   set(hvec_filter(16),'string',listp);   
   filter_w2(6);%redraw sens. functions
   
elseif(par==6) %redraw graphs
   global xscal yscal;
   global hvec_filter;
%hvec_filter=[h0 hax_flt hax_syp hax_sup hsld_att hsld_frq hsld_dmp htxt_att htxt_frq htxt_dmp ...
%      		htxt_num htxt_den hrad_syp hrad_sup htxt_flt hlst_flt];
	global filter_var;
   if filter_var.active==1, %Syp
      c_syp=[1 0 0];c_sup=[0 1 0];c_sypf=[0 0 1];c_supf=[0 1 1];
   else
      c_syp=[0 1 0];c_sup=[1 0 0];c_sypf=[0 1 1];c_supf=[0 0 1];
   end;
   %convolution of sens. functions with the filters
%Syp   
   vecfilter=filter_var.fsyp;
   sypnum=1;
   denom=1;
   if ~isempty(vecfilter),
	   for k=1:length(vecfilter), 
		   [num,den,om_n,xi_n,om_d,xi_d]=filter22(vecfilter(k).Mt,vecfilter(k).ft,vecfilter(k).xin,filter_var.Ts);
	      sypnum=conv(sypnum,num);
	      denom=conv(denom,den);
      end;
   end;
%Sup   
   vecfilter=filter_var.fsup;   
   supnum=1;
   if ~isempty(vecfilter),
	   for k=1:length(vecfilter), 
		   [num,den,om_n,xi_n,om_d,xi_d]=filter22(vecfilter(k).Mt,vecfilter(k).ft,vecfilter(k).xin,filter_var.Ts);
	      supnum=conv(supnum,num);
	      denom=conv(denom,den);
      end;
   end;
   %compute
   P=conv(filter_var.AP,filter_var.PD);
   Hs=filter_var.Hs;
   Hr=filter_var.Hr;
   Papp=P;
   hsapp=conv(sypnum,Hs);
   hrapp=conv(supnum,Hr);
   Papp=conv(P,denom);
   [R,S,nR,nS]=bezout(filter_var.A,filter_var.B,hsapp,hrapp,Papp);
   sypnum=conv(filter_var.A,conv(hsapp,S));
   supnum=conv(filter_var.A,conv(hrapp,R));
   denom=addvec(conv(filter_var.A,conv(hsapp,S)),conv(filter_var.B,conv(hrapp,R)));
   
   %draw Syp
   index=get(hvec_filter(16),'value');
   vecfilter=filter_var.fsyp;
   [s,f]=freqz(sypnum,denom,512,1/filter_var.Ts);
   s=abs(s);
   ft=filter_var.Wfn;%freq of templates
   sx='frequency [Hz]';
   sy='Magnitude of Syp [-]';
   if (xscal==2), 
      f=2*pi*f;
      ft=filter_var.Wfn*2*pi;
   sx='frequency [rad/s]';         
   elseif(xscal==3), 
      f=f*filter_var.Ts;
      sx='frequency f/f_s[-]';  
      ft=filter_var.Wfn*filter_var.Ts;
   end;
   if (yscal==1), 
      for k=1:length(s), if s(k)<PREC, s(k)=PREC;end;end;         
      s=20*log10(s);
      sy='Magnitude of Syp [dB]';            
      templ=filter_var.Wsyp;
   elseif(yscal==2),%linear
      templ=10.^(filter_var.Wsyp/20);
   end;
	axes(hvec_filter(3));
   if isempty(filter_var.hsfun),
		hold off;
		plot(ft,templ,'k');
		hold on;
      filter_var.hsfun=plot(f,s);
      set(filter_var.hsfun,'Color',c_syp);
      y=get(hvec_filter(3),'Ylim');
      filter_var.hfposyp=[];
      for k=1:length(vecfilter), 
         filter_var.hfposyp(k)=plot([vecfilter(k).ft vecfilter(k).ft],y);%filter positions
         set(filter_var.hfposyp(k),'Color',c_sypf,'Linestyle','--','Marker','none');         
         if (filter_var.active==1)&(k==index), set(filter_var.hfposyp(k),'Marker','v');end;
      end;
      title(sy);
      grid on;
   else
      y=get(hvec_filter(3),'Ylim');
		set(filter_var.hsfun,'YData',s,'Color',c_syp);
      for k=1:length(vecfilter), 
         set(filter_var.hfposyp(k),'XData',[vecfilter(k).ft vecfilter(k).ft], ...
            'Color',c_sypf,'Marker','none','YData',y);
         if (filter_var.active==1)&(k==index), set(filter_var.hfposyp(k),'Marker','v');end;         
      end;      
   end;
   %draw Sup
   vecfilter=filter_var.fsup;
   [s,f]=freqz(supnum,denom,512,1/filter_var.Ts);
   s=abs(s);
   ft=filter_var.Wfn;%freq of templates
   sx='frequency [Hz]';
   sy='Magnitude of Sup [-]';
   if (xscal==2), 
      f=2*pi*f;
      ft=filter_var.Wfn*2*pi;
   sx='frequency [rad/s]';         
   elseif(xscal==3), 
      f=f*filter_var.Ts;
      sx='frequency f/f_s[-]';  
      ft=filter_var.Wfn*filter_var.Ts;
   end;
   if (yscal==1), 
      for k=1:length(s), if s(k)<PREC, s(k)=PREC;end;end;         
      s=20*log10(s);
      sy='Magnitude of Sup [dB]';            
      templ=filter_var.Wsup;
   elseif(yscal==2),%linear
      templ=10.^(filter_var.Wsup/20);
   end;
   axes(hvec_filter(4));
   if isempty(filter_var.hsfun2),
	   hold off;
		plot(ft,templ,'k');
		hold on;
      filter_var.hsfun2=plot(f,s);
      set(filter_var.hsfun2,'Color',c_sup);
      y=get(hvec_filter(4),'Ylim');      
      filter_var.hfposup=[];
      for k=1:length(vecfilter), 
         filter_var.hfposup(k)=plot([vecfilter(k).ft vecfilter(k).ft],y);
         set(filter_var.hfposup(k),'Color',c_supf,'Linestyle','--','Marker','none');
         if (filter_var.active==2)&(k==index), set(filter_var.hfposup(k),'Marker','v');end;         
      end;
	   title(sy);
      xlabel(sx);
      grid on;
   else
      set(filter_var.hsfun2,'YData',s,'Color',c_sup);
      for k=1:length(vecfilter), 
         y=get(hvec_filter(4),'Ylim');
         set(filter_var.hfposup(k),'XData',[vecfilter(k).ft vecfilter(k).ft], ...
            'Color',c_supf,'Marker','none','YData',y);
         if (filter_var.active==2)&(k==index), set(filter_var.hfposup(k),'Marker','v');end;         
      end;
   end;
   %set axes limits
   yl=get(hvec_filter(3),'Ylim');
   if yl(1)<-60, yl(1)=-60;end;
   set(hvec_filter(3),'Ylim',yl);
   yl=get(hvec_filter(4),'Ylim');
   if yl(1)<-60, yl(1)=-60;end;
   set(hvec_filter(4),'Ylim',yl);
   
elseif(par==7) %callback for list
   global hvec_filter;
%hvec_filter=[h0 hax_flt hax_syp hax_sup hsld_att hsld_frq hsld_dmp htxt_att htxt_frq htxt_dmp ...
%      		htxt_num htxt_den hrad_syp hrad_sup htxt_flt hlst_flt];
	global filter_var;
   index=get(hvec_filter(16),'value');
   if filter_var.active==1, %Syp
      vecfilter=filter_var.fsyp;
   elseif filter_var.active==2, %Sup
      vecfilter=filter_var.fsup;
   end;
 	val=(vecfilter(index).Mt-filter_var.minatt)/(filter_var.maxatt-filter_var.minatt);
   set(hvec_filter(5),'value',val);
	val=(vecfilter(index).ft-filter_var.minfreq)/(filter_var.maxfreq-filter_var.minfreq);
   set(hvec_filter(6),'value',val);      
	val=(vecfilter(index).xin-filter_var.mindamp)/(filter_var.maxdamp-filter_var.mindamp);      
   set(hvec_filter(7),'value',val);
   filter_w2(5);%recompute current filter
   
elseif (par==8) %add filter
   global hvec_filter;
%hvec_filter=[h0 hax_flt hax_syp hax_sup hsld_att hsld_frq hsld_dmp htxt_att htxt_frq htxt_dmp ...
%      		htxt_num htxt_den hrad_syp hrad_sup htxt_flt hlst_flt];
	global filter_var;
   if filter_var.active==1, %Syp
      vecfilter=filter_var.fsyp;
      filtn=struct('ft',1/(4*filter_var.Ts),'Mt',-1,'xin',0.5);
      vecfilter=[vecfilter filtn];
      filter_var.fsyp=vecfilter;
      filter_var.hsfun=[];
   elseif filter_var.active==2, %Sup
      vecfilter=filter_var.fsup;
      filtn=struct('ft',1/(4*filter_var.Ts),'Mt',-1,'xin',0.5);
      vecfilter=[vecfilter filtn];
      filter_var.fsup=vecfilter;
      filter_var.hsfun2=[];      
   end;
   listp={};
   for K=1:length(vecfilter),
      s=sprintf('f%d : %gHz, %gdB, %g',K,vecfilter(K).ft,vecfilter(K).Mt,vecfilter(K).xin);
      listp(K)=cellstr(s);
   end;
   set(hvec_filter(16),'string',listp,'value',K);
   if length(vecfilter)==1, %enable all
      set(hvec_filter(5),'enable','on');
      set(hvec_filter(6),'enable','on');      
      set(hvec_filter(7),'enable','on');
      set(hvec_filter(16),'enable','on');
   end;
   filter_w2(7); %callback for list
   
elseif (par==9) %remove filter
   global hvec_filter;
%hvec_filter=[h0 hax_flt hax_syp hax_sup hsld_att hsld_frq hsld_dmp htxt_att htxt_frq htxt_dmp ...
%      		htxt_num htxt_den hrad_syp hrad_sup htxt_flt hlst_flt];
	global filter_var;
   index=get(hvec_filter(16),'value');
   if filter_var.active==1, %Syp
      vecfilter=filter_var.fsyp;
      if length(vecfilter)>1,
         vecfilter=[vecfilter(1:index-1) vecfilter(index+1:length(vecfilter))];
      elseif length(vecfilter)==1,
         vecfilter=[];
      else %no filter to remove
         return;
      end;
      filter_var.fsyp=vecfilter;
      filter_var.hsfun=[];
   elseif filter_var.active==2, %Sup
      vecfilter=filter_var.fsup;
      if length(vecfilter)>1,
         vecfilter=[vecfilter(1:index-1) vecfilter(index+1:length(vecfilter))];
      elseif length(vecfilter)==1,
         vecfilter=[];
      else %no filter to remove
         return;
      end;
      filter_var.fsup=vecfilter;
      filter_var.hsfun2=[];
   end;
   filter_w2(4);%init for filters
   filter_w2(6);%redraw functions
   
elseif(par==10), %set Syp active
   global hvec_filter;
%hvec_filter=[h0 hax_flt hax_syp hax_sup hsld_att hsld_frq hsld_dmp htxt_att htxt_frq htxt_dmp ...
%      		htxt_num htxt_den hrad_syp hrad_sup htxt_flt hlst_flt];
	global filter_var;
   filter_var.active=1;
   set(hvec_filter(13),'FontSize',10,'ForegroundColor',[1 0 0]);
   set(hvec_filter(14),'FontSize',8,'ForegroundColor',[0 0 0]);   
   filter_w2(4);%init
   
elseif(par==11), %set Sup active
   global hvec_filter;
%hvec_filter=[h0 hax_flt hax_syp hax_sup hsld_att hsld_frq hsld_dmp htxt_att htxt_frq htxt_dmp ...
%      		htxt_num htxt_den hrad_syp hrad_sup htxt_flt hlst_flt];
	global filter_var;
   filter_var.active=2;   
   set(hvec_filter(13),'FontSize',8,'ForegroundColor',[0 0 0]);
   set(hvec_filter(14),'FontSize',10,'ForegroundColor',[1 0 0]);   
   filter_w2(4);%init
   
elseif(par==12) %numerator coeff
   global hvec_filter filter_var;
   if filter_var.active==1, %Syp
      vecfilter=filter_var.fsyp;
   elseif filter_var.active==2, %Sup
      vecfilter=filter_var.fsup;
   end;
   inx=get(hvec_filter(16),'value');
   [num,den,om_n,xi_n,om_d,xi_d]=filter22(vecfilter(inx).Mt,vecfilter(inx).ft,vecfilter(inx).xin,filter_var.Ts);
   r=roots(num);
   num=poly(r);
   dispcw(num2str(num));
   
elseif(par==13) %denominator coeff 
   global filter_var hvec_filter;
   if filter_var.active==1, %Syp
      vecfilter=filter_var.fsyp;
   elseif filter_var.active==2, %Sup
      vecfilter=filter_var.fsup;
   end;
   inx=get(hvec_filter(16),'value');
   [num,den,om_n,xi_n,om_d,xi_d]=filter22(vecfilter(inx).Mt,vecfilter(inx).ft,vecfilter(inx).xin,filter_var.Ts);
   r=roots(den);
   den=poly(r);
   dispcw(num2str(den));
end;
